'*********************************************************************
'                            LCD_TAST_SU.BAS
'                         Flash of Inspiration I
'
'(c) W.Harth (DF2OAG)
'(c) modified by Ing.Bro St.Lehmann, D-77756 Hausach, SL@iL-online.de
'*********************************************************************
rem      Demoprogramm fr LC-Anzeige, 12er Tastatur und Summer  
rem      
rem      Einrichten der Platine
rem
rem      Tasten PortB -> durchschalten
rem      LCD an PortB -> glatt durchschalten
rem      Stift PortA,0 mit Stift LS verbinden (Summer an PortA,0)
rem      Status-Anzeige Port B, muss abgeschaltet sein!
rem
rem      Programm in PIC 16F628 laden und starten
rem
rem      Bei jedem Druck auf eine Taste, erscheint der Wert der Taste
rem      auf der LCD und ein kurzer Ton ist zu hren
rem
rem      --------------------------------------------------------------
rem      demonstrates how to work with LCD, keypad and buzzer
rem
rem      the following settings and connections must be done
rem
rem      put switches "Tasten PortB" all to on 
rem      put switches "LCD an PORTB" 1 .. 6 to on
rem      connect LS to PortA,0 (buzzer onto port RA,0)
rem      switches of S5 all off
rem
rem      load compiled program into "Flash Of Inspiration I"
rem
rem      when pressing a key its value is displayed on lcd and 
rem      a short sound is generated.


  
'Watchdog off, all comparators off, MCLR- and OSC2-Pin are used for io
         define device 16f628
         config wdt_off
         config ircp_osc
         config cmcfg7
         config MCLR_INT
     
         xtal 4.00                     'xtal frequency

         tris ra,0                     'all pins are output now
         tris rb,0                     'all pins are output now
         output ra,0                   'all pins have low level
         output rb,0                   'all pins have low level
         lcdinit rb,2,16,              'init. lcd with each 16 chars on 2 lines 
         
'conversation table for keypad. No keypressed returns "A", key 0 returns 11 etc.
'this table depends on how the keypad is connected to port 
         define keys rb,"A",11,7,4,1,0,8,5,2,12,9,6,3
       

rem Variablen
'we use only two byte variables on ram location 20h and 21h
         define tmp1=$20
         define tmp2=$21
         
         

         lcdwrite 1,1,"Test LCD+Tasten"          'when starting, show this text 
         wait 2000                               'for 2 second
         lcdwrite 1,1,"               "          'then delete the first line


 
start:
         
         inkey tmp1                              'read keypad
         if tmp1=tmp2 then goto l2               'compare with old value, same, change nothing
         let tmp2=tmp1                           'else old value becomes new value
         if tmp1=65 then goto l1                 'if no key is pressed goto I1
         lcdwrite 1,1,"               "          'else clear line 1 and line 2
         lcdwrite 2,1,"               "
         lcdwrite 1,3,tmp1                       'write value in first line
         sound ra.0,800,400                      'make a little noise
         goto start                              'do all again
l1:
         lcdwrite 1,1,"keine Taste"
         lcdwrite 2,1,"gedrckt"                 'kein Schreibfehler =dez 245,hex F5
         goto start                              'Umlaut on PC is not Umlaut on LCD

l2:
         wait 20                                 'to slow down execution speed
         goto start                              'back to the main loop



