'*************************************************************
'                            Terminal.BAS
'                            26.06.2004
'
'(c) Ing.Bro Lehmann, Frstenbergstrae 8a, D-77756 Hausach
'Tel. +49 (0)7831 452, Fax +49 (0)7831 96428, email: SL@iL-online.de
'*****************************************************************
'Dieses Programm zeigt die Funktionsweise von SERIN und SEROUT. Es 
'muss eine RS232-Verbindung mit dem PC bestehen. Dort wird ein ein-
'faches Terminalprogramm gestartet. Die bertragungsparameter sind
'4800 Baud, 8-Datenbits, keine Paritt und alle Handshakes abge-
'schaltet. Ein ber die Tastatur eingegebenes Zeichen wird an die FOI-
'Platine betragen, dort angezeigt und falls die Zeichen im Bereich
'von 'a' bis 'z' liegen in Grobuchstaben konvertiert. Danach erfolgt
'die Rcksendung des original oder modifizierten Zeichens.
'
'Folgende Verbindungen sind auf der Platine notwendig:
'PortA,0 nach TX   und   PortA,1 nach RX
'
'Die RS232-Verbindung ist ein Standard-Kabel, kein Nullmodem-Kabel!!!
'
'
'This program demonstrates the using of SERIN and SEROUT. FOI must be
'connected to a computer with a running terminal program. Select 
'following settings: 4800 baud, 8 data bits, no parity and no handshake.
'A character entered on the computer's keyboard is sent to the 
'evaluation board. There it is displayed and if between 'a' and 'z'
'it is converted into upper cases. Then the original or converted
'character is sent back to the computer.
'
'Following connections must be done:
'PortA,0 to TX   and  PortA,1 to RX
'

'defines the type of PIC controller, turns watchdog off, selects internal
'oscillator, turns all comparators off, mclr and osc2 pin becomes io 
         define device 16f628
         config wdt_off
         config ircp_osc
         config cmcfg7
         config mclr_int

         xtal 4                        'internal oscillator runs with 4 MHz
         $ncaldef                      'no calibration value is needed 
         
         define txd = ra,0             'transmit line is on Port A bit 0
         define rxd = ra,1             'receive line is on Port A bit 1
         
         define baud = 4800 as const   'baud is not a variable, but a constant
                                       'value
         
         define char = $20 as byte     'we need only one variable
         
cold:
         wait 200                      'wait 0.2 sec after power on
         goto start                    'skip all subroutines

init:
         tris ra,%11111110             'Port A,0 becomes output, rest input
         set ra,0                      'on serial line pause is high
         lcdinit rb,2,16               'tell the compiler what kind of lcd
         lcdclear                      'erase lcd
         return                        'return to caller
                
start:
         gosub init                    'peripherial needs to be initialized
         lcdwrite 1,1,"Terminal V1.1"  'this is the first visible action
loop:
         serin rxd,baud,char           'wait until a character is received
         lcdwrite 2,1,char             'write the ascii value of this character
         lcdwrite 2,8,char,#           'write the character, too
         if char<"a" then goto loop1   'we want to convert lower case characters
         if char>"z" then goto loop1   'in upper case characters
         res char,5                    'here we convert
loop1:
         serout txd,baud,char          'then we send the character back 
         goto loop                     'and wait for the next character
         