'****************************************************************************
'                            Vor- und Rckwrtszhler
'                                F_R_Counter.BAS
'
'                               Stand: 24.06.2009
'
'                                  5. Schritt 
'
'(c) Ing.Bro Lehmann, Frstenbergstrae 8a, 77756 Hausach, www.iL-online.de
'****************************************************************************

'Historie
'Schritt5: nun arbeiten auch die anderen Stellen und werden dabei hoch-
'          gezhlt. Die Pause ist kleiner, damit der Zhler schneller luft
'          Es mssen weitere Variablen fr den Zhler verwendet werden (DEFINE)
'          Auch der Multiplexbetrieb wird nun verwendet
'          Allerdings luft der Zhler nun deutlich schneller, ohne dass man
'          darauf Einfluss hat. Denn ndert man die 5ms beginnt es u.U. zu flimmern
'          Dies ist allerdings nicht so tragisch, da das Endprodukt nicht automatisch
'          hochzhlen soll.
'Schritt4: es wird auf de hintersten Stelle von 0 bis 9 hochgezhlt
'          zum ersten Mal wird eine Variable definiert, ein Unterprogamm
'          zur Zeichenumsetzung verwendet und der TRIS-Befehl eingesetzt
'Schritt3: nun soll das Segment blinken
'Schritt2: weil mehr wie ein Segment leuchten, werden die brigen explizit 
'          abgeschaltet.

'Besonderheiten
'Auf der PICUP-Platine mssen die Steckbrcken (Jumper) wie folgt gesteckt sein:
'JP1A und JP1B  jeweils 2-3   -> externer Oszillator (Quarz)
'JP2A und JP2B  jeweils 2-3   -> T3 an RA1  und T2 an RA2

'die beiden nachfolgenden Schalter sind notwendig, wenn das PicKit2 als
'Programmiergert verwendet wird.
         $LIST  /M_OBJ
         $LIST  OBJ2HEX

'hier wird der Prozessortyp und dessen Spezifikationen definiert
         DEFINE DEVICE 16F628A
         CONFIG CMCFG7                 'interene Komparatoren abschalten, damit
                                       'die Pins als normale Ein-/Ausgnge arbeiten
         CONFIG HS_OSC                 'Wenn ein Quarz verwendet wird
         CONFIG MCLR_INT               'der MCLR-Pin soll als IO-Pin arbeiten
         CONFIG WDT_OFF                'verhindert, dass nach 2,3 Sek ein Reset 
                                       'erzeugt wird
                                       
         XTAL   4.096
         
'hier folgen die Variablendeklarationen (8, 16 und ggf. 32 Bit)         
         DEFINE    Count0 = AUTO AS BYTE         'Zhlervariable (1er-Stelle)
         DEFINE    Count1 = AUTO AS BYTE         'nchste Stelle des Zhler (10er)
         DEFINE    Count2 = AUTO AS BYTE         '100er Stelle
         DEFINE    COUNT3 = AUTO AS BYTE         '1000er Stelle
         
         DEFINE    Wert = AUTO AS BYTE           'fr die Parameterbergabe an BCD2SEG
         DEFINE    Muster = AUTO AS BYTE         'Segmentmuster

'hier werden die Bitvariablen definiert


'hier werden die Konstanten definiert

'-------------------------------------------
'ab hier wird Code fr den Prozessor erzeugt
'-------------------------------------------
'falls Unterprogramme verwendet werden, werden diese zuerst bersprungen

cold:
         GOTO      start
         
'hier stehen ggf. die Unterprogramme

'bcd2seg wandelt eine Zahl zwischen 0 und 9 in ein Bitmuster fr die
'Siebensegmentanzeige um
bcd2seg:
         IF        Wert=0 THEN LET Muster = %00100001
         IF        Wert=1 THEN LET Muster = %01111101
         IF        Wert=2 THEN LET Muster = %00010011
         IF        Wert=3 THEN LET Muster = %00011001
         IF        Wert=4 THEN LET Muster = %01001101
         IF        Wert=5 THEN LET Muster = %10001001
         IF        Wert=6 THEN LET Muster = %10000001
         IF        Wert=7 THEN LET Muster = %00111101
         IF        Wert=8 THEN LET Muster = %00000001
         IF        Wert=9 THEN LET Muster = %00001001
         RETURN

'hier beginnt das Hauptprogramm
start:
         LOW       RA,1                '?. Digit (T?) ausschalten
         LOW       RA,2                '?. Digit (T?) ausschalten
         LOW       RA,4                '?. Digit (T?) ausschalten
         LET       Count0 = 0          'Zhler mit 0 initialisieren
         LET       Count1 = 0          'auch die brigen Stellen auf 0 setzen
         LET       Count2 = 0
         LET       Count3 = 0
         
         TRIS      RB,0                'alle Pins von RB arbeiten als Ausgnge
loop:         
         LET       Wert = Count0       'jetzt muss gemultiplext werden
         GOSUB     bcd2seg             'Zahl in Wert umwandeln in Seg.muster
         OUTPUT    RB,Muster           'dieses Muster an Port RB anlegen
         HIGH      RA,0                '1. Digit (T4) einschalten
         WAIT      5                   '5ms warten. Zeit entscheidet ber Flackern der Anzeige
         LOW       RA,0                '1. Digit (T4) ausschalten
         
         LET       Wert = Count1       'jetzt die nchste Stelle
         GOSUB     bcd2seg             'Zahl in Wert umwandeln in Seg.muster
         OUTPUT    RB,Muster           'dieses Muster an Port RB anlegen
         HIGH      RA,1                '2. Digit (T3) einschalten
         WAIT      5                   '5ms warten
         LOW       RA,1                '2. Digit (T3) ausschalten

         LET       Wert = Count2       'jetzt die 100er-Stelle
         GOSUB     bcd2seg             'Zahl in Wert umwandeln in Seg.muster
         OUTPUT    RB,Muster           'dieses Muster an Port RB anlegen
         HIGH      RA,2                '3. Digit (T2) einschalten
         WAIT      5                   '5ms warten
         LOW       RA,2                '3. Digit (T2) ausschalten

         LET       Wert = Count3       'jetzt die 1000er-Stelle
         GOSUB     bcd2seg             'Zahl in Wert umwandeln in Seg.muster
         OUTPUT    RB,Muster           'dieses Muster an Port RB anlegen
         HIGH      RA,4                '4. Digit (T1) einschalten
         WAIT      5                   '5ms warten
         LOW       RA,4                '4. Digit (T1) ausschalten


         LET       Count0=Count0 + 1   'Zhler hochzhlen lassen
         IF        Count0<10 THEN GOTO loop    'kein berlauf, keine neue Stelle notwendig

         LET       Count0=0            '1er-Zhler wieder auf 0 setzen, dafr 10er erhhen
         LET       Count1=Count1 + 1
         IF        Count1<10 THEN GOTO loop     '10er Stelle kein berlauf
         
         LET       Count1 = 0          '10er-Stelle zurck auf 0
         LET       Count2 = Count2 + 1 '100er-Steller erhhen
         IF        Count2<10 THEN GOTO loop
         
         LET       Count2 = 0          '100-Stelle auf 0
         LET       Count3 = Count3 + 1 '1000-er Stelle hochzhlen
         IF        Count3<10 THEN GOTO loop
         
         LET       Count3=0            'wenn hier angekommen, ist der komplette Zhler
                                       'einmal durchgelaufen 

         GOTO      LOOP                'das Ganze luft nun endlos

         END
         
