'"*************************************************************************************                                                                           
'"
'"                 PICUP Platine des AATiS mit PIC 16F628A
'"                 Reaktionstest
'"                 DF2OAG, Juni 2009
'"*************************************************************************************
'"
'"       picup1g.bas
'"       Basicprogramm fr den iL_BAS16 Version 6.0 erstellt und mit PICKIT2 programmiert
'"
'"       Reaktionstest
'"       Ziel ist es, die in der linken Anzeige dargestellte Ziffer auf den rechten Anzeige
'"       durch drcken der Stopp-Taste ebenfalls zu sehen. 
'"       Die Bedienung:
'"       Nach dem Einschalten zhlt die linke Stelle langsam von 1 bis 5.
'"       Diese Werte legen den Schwierigkeitsgrad fest. 
'"                 1 sehr langsam und leicht
'"                 5 sehr schnell und schwierig
'"       Durch das Drcken der Start-Taste wird der in der Anzeige
'"       erscheinende Schwierigkeidgrad fr den Reaktionstest bernommen.
'"
'"       Jetzt erscheint in der linken Anzeige eine Ziffer. Diese Ziffer muss 
'"       mit der Stopp-Taste auf den drei restlichen Anzeigen nacheinander 
'"       ebenfalls festgehalten werden. Die Anzahl der richtig getroffenen
'"       werte wird nach 5 Durchgngen im Display angezeigt. Wer den hchsten
'"       Wert erreicht hat gewonnen. Bei gleichen Punkten den Schwierigkeitsgrad
'"       erhhen, bis ein Sieger ermittelt ist. Der maximal Wert bei 5 Durchgngen
'"       ist 15 Punkte.
'"       Auf der Anzeige steht dann ..15
'"       
'"       Durch Drcken der Start-Taste beginnt ein neuer Zyklus
'"
'"       Auf der PICUP-Platine mssen die Steckbrcken wie folgt gesteckt sein:
'"       JP2A 1-2   JP1A 1-2   JP1B 1-2   JP2B 1-2   
'"       JP-RA1 off    JP-RA2 on    JP-RA3 on   JP-RA5 on 
'"
'"       viel Spa beim ausprobieren
'"

         $list /m_obj        'erzeugt ein Microchipkompatibles Datenformat z.B. fr PicKit2
         $List OBJ2HEX       'erzeugt statt einer OBJ-Datei eine HEX-Datei (      "        )
         
         define device 16F627
         
'"Konfiguration
          
         conf0 %00010000     '" INTOSC mit i/0 Pin, WDT off, PWTRE on, Boren off, MCLRE intern
                             '" LVP off 
         conf1 %00100001     '" CP off
         
         set cm0             '"Comparatoren aus
         set cm1             '"Comparatoren aus
         set cm2             '"Comparatoren aus
  
  
         tris ra,%00101110   '" I/O Pin des Ports RA Konfigurieren 0=Ausgang, 1= Eingang
         tris rb,0           '" Alle Pin des Port RA als Ausgnge konfiguriert
         
         Output ra,0         '" Port RA Pins alle Low 
         output rb,0         '" Port RB Pins alle Low  
         
'" Variablen definieren

         define segment=   auto as byte
         define ii =       auto as word
         define wert =     auto as byte
         define wert1=     auto as byte
         define wert2=     auto as byte
         define wert3=     auto as byte
         define wert4=     auto as byte
         define stelle=    auto as byte  '" stelle der LED siebensegmentanzeige
         define ra_set=    auto as byte  '" speichert die angezeigte Displaystelle zur Ausgabe an Port RA
         define sgrad=     auto as word  '" Schwierigkeitsgrad 1-> sehr leicht 5-> extrem schwer
         define zufall=    auto as byte  '" Zufallszahl 
         define Ergebnis=  auto as byte
         define durchgang= auto as byte  
                
'" Variablen setzen
         
start:
         
         let stelle=1                  '" 1. Stelle von links Aktiv
         let wert1=11                  '" 1. Stelle von links Anzeige Dunkel
         let wert2=11                  '" 2. Stelle von links Anzeige Dunkel
         let wert3=11                  '" 3. Stelle von links Anzeige Dunkel
         let wert4=11                  '" 4. Stelle von links Anzeige Dunkel
         
         let durchgang=0
         let Ergebnis=0
         let wert1=1
         
         gosub display
         if ra,3=1 then goto start
         
         let ii=10000
start1:                                '" Schwierigkeitsstufe auswhlen 1 sehr leicht 5 extrem schwer
        
        gosub display
        if ra,3=1 then goto start2     '" Schwierigkeitsgrad speichern
        
        dec ii
        if ii=0 then goto start1a
        goto start1

start1a:
        let ii=10000         
        inc wert1
        if wert1=6 then let wert1=1
        
        goto start1

start2:                                '" Schwierigkeitsgrad speichern
         if wert1=1 then let sgrad=9000
         if wert1=2 then let sgrad=7000
         if wert1=3 then let sgrad=5000
         if wert1=4 then let sgrad=3000
         if wert1=5 then let sgrad=1000

stelle1:
         if durchgang=5     then goto ergeb          'Zeige Ergebnis an 
         gosub zufalls                           'Zufallszahl generieren

         let wert1=zufall
        
stelle2:
        let wert2=0
        gosub display
        if ra,5=1 then goto stelle2
        let ii=sgrad
        
stelle2a:
        gosub display
        
        if ra,5=1 then goto stelle3
        
        dec ii
        if ii=0 then goto stelle2b
        goto stelle2a
        
stelle2b:
        let ii=sgrad
        
        gosub zufalls
        let wert2=zufall
        
        goto stelle2a
        
stelle3:
        
        let wert3=0
        gosub display
        if ra,5=1 then goto stelle3
        if wert2=wert1 then inc ergebnis
        let ii=sgrad
        
stelle3a:
        gosub display
        
        if ra,5=1 then goto stelle4
        
        dec ii
        if ii=0 then goto stelle3b
        goto stelle3a
        
stelle3b:
         let ii=sgrad
         gosub zufalls
         let wert3=zufall
        
         goto stelle3a
        
stelle4:
        
        let wert4=0
        gosub display
        if ra,5=1 then goto stelle4
        if wert3=wert1 then inc ergebnis
        let ii=sgrad
        
stelle4a:
        gosub display
        
        if ra,5=1 then goto durch
        
        dec ii
        if ii=0 then goto stelle4b
        goto stelle4a
        
stelle4b:
         let ii=sgrad
         gosub zufalls
         let wert4=zufall
        
         goto stelle4a

durch:                                 '" Durchgang beendet        
        if wert4=wert1 then inc ergebnis
durch1:
        gosub display
        if ra,5=1 then goto durch1
        
        inc durchgang
        goto stelle1
        
        
ergeb:                                 '" Ausgabe des Ergebnisses

         let wert1=10
         let wert2=10
         if ergebnis >=10 then goto ergeb1
       
         let wert3=11
         let wert4=ergebnis  
         goto ergeb2
ergeb1:
         let wert3=1
         let wert4=ergebnis-10
         
ergeb2:         
         gosub display
         if ra,3=1 then goto start
         
         goto ergeb2

Display:
        
        if stelle,0=1 then goto st1
        if stelle,1=1 then goto st2
        if stelle,2=1 then goto st3
        if stelle,3=1 then goto st4
         
st1:       
        let wert=wert1  
        let ra_set=%00010000
        let stelle=2
        goto display2
st2:       
        let wert=wert2  
        let ra_set=%01000000
        let stelle=4
        goto display2
st3:       
        let wert=wert3  
        let ra_set=%10000000
        let stelle=8
        goto display2
st4:       
        let wert=wert4  
        let ra_set=%00000001
        let stelle=1                   '" Stelle auf den Anfang setzen
        goto display2
         
display2:
         output ra,0                                          '" Display dunkelschalten
         on wert gosub z0,z1,z2,z3,z4,z5,z6,z7,z8,z9,zD,zN    '" Ziffer auf Siebensegment kodieren
         output rb,segment                                    '" Segmente der Anzeige setzen
         output ra,ra_set                                     '" Display an gewnschter Stelle einschalten       
         
         return
         
         
         


'        Ziffern 0-9
z0:
         let segment=%00100001
         return
z1:
         let segment=%01111101
         return
z2:
         let segment=%00010011
         return
z3:
         let segment=%00011001
         return
z4:
         let segment=%01001101
         return
z5:
         let segment=%10001001
         return
z6:
         let segment=%10000001
         return
z7:
         let segment=%00111101
         return
z8:
         let segment=%00000001
         return
z9:
         let segment=%00001001
         return
   
'        Dezimal-Punkt         
zD:
         let segment=%11111110
         return

'        Keine Anzeige, alle Segmente Dunkel
zN:      
         let segment=%11111111
         return
         
zufalls:                     '" Zufallszahl generieren
         let zufall=zufall+3
         if zufall=30 then let zufall=0
         if zufall > 19 then let zufall=zufall-20
         if zufall > 9  then let zufall=zufall-10
         
         return
         
         


         end