'********************************************************************
'                            Wrfel.BAS
'                            14.05.2009
'                             
'
'        Das Programm wurde fr die iL-Troll Platine TB1 geschrieben.
'                            www.iL-troll.de
'
'        Das Programm kann direkt fr die Prozessoren vom Typ PIC 18F252 oder
'        vom Typ PIC 16F873A compiliert werden. Die Auswahl geschieht durch
'        setzen des Compiler-Schalters auf 1, wenn PIC 18F252 gewnscht ist.
'        Fr den Prozessor 16F873A, den Compiler-Schalter auf 0 setzen.
'
'                    (c) Stefan Lehmann & Wolfram Harth
'
'********************************************************************
'
'
'
' Anweisungen zum Erzeugen eines Microchip kompatilen HEX-Files
         $LIST /M_OBJ 
         $LIST obj2hex

' Hier werden die zwei Compiler-Schalter definiert. Es darf nur ein
' Compiler-Schalter auf den Wert 1 gesetzt sein.

         'define PIC18F252 = 1 as const ' Das Programm wird fr den PIC 18F252 kompiliert

         define PIC18F252 = 0 as const ' Das Programm wird fr den PIC 16 F 873A kompiliert


'********************************************************************
'
'        Hier beginnt der Konfigurationsbereich fr den PIC 18F252
'
'        Wenn die Konstante PIC18F252 auf den Wert 1 gesetzt ist, werden diese 
'        Programmzeilen bis zum Compiler-Schalter $ELSE kompiliert.
'        Die Zeilen zwischen den Compiler-Schaltern $ELSE und $ENDIF werden ignoriert.

         $IF PIC18F252

' Einstellen der Configurations Worte
' Der Prozessor PIC 18F252 besitzt 11 Configurations-Bytes
' siehe Datenblatt des PIC 18F252

         CONF1  =$22    '300001h, CONFIG1H, HS OSC                  
         CONF2  =$0F    '300002h, CONFIG2L,      
         CONF3  =$00    '300003h, CONFIG2H, WDT off
         CONF5  =$01    '300005h, CONFIG3H, 
         CONF6  =$81    '300006h, CONFIG4L, 'Debug off, LVP off 
         CONF8  =$0F    '300008h, CONFIG6L, 
         CONF9  =$C0    '300009h, CONFIG5H, 
         CONF10 =$0F    '30000Ah, CONFIG6L, 
         CONF11 =$E0    '30000Bh, CONFIG6H, 
         CONF12 =$0F    '30000Ch, CONFIG7L,  
         CONF13 =$40    '30000Dh, CONFIG7H, 
         


         DEFINE DEVICE 18F252
         
         CONFIG adcfg 6        ' Nur digitale I/0, keine analogen Eingnge
         
         
'********************************************************************


         $ELSE               ' Der folgende Text wird kompiliert,
                             ' wenn der Compiler-Schalter PIC18F252
                             ' den Wert 0 hat.

'********************************************************************
'
'        Hier beginnt der Konfigurationsbereich fr den PIC 16F873A
'
'        Wenn die Konstante PIC18F252 auf den Wert 0 gesetzt ist, werden diese 
'        Programmzeilen bis zum Compiler-Schalter $ENDIF kompiliert

        
         

' Einstellen der Configurations Worte
'
' Siehe Datenblatt des PIC 16F873A, das Configurations-Wort hat 14 Bit,
' die auf 2 Byte verteilt sind.

         CONF1  =$2F         'Bit 8-13, des Configuration Wortes
         CONF0  =$09         'Bit 0-7,  des Configuration Wortes
                             ' HS Oszillator, WDT-off, Protect-off
         


         DEFINE DEVICE 16F873A
         
         CONFIG ADCFG 6    'nur digitale I/O, keine analogen Eingnge
         
         $ENDIF
'********************************************************************



'Variablendeklaration 
         DEFINE Augenzahl= auto as byte 'Wrfelwert (1-6) 

'Konstantendefinitionen
         DEFINE Taste=rc,4                  'mittlere Taste S1
         DEFINE Led1 = Rc,7                 'Leds werden ihren
         DEFINE Led2 = Rb,0                 'IO-Pins zugeordnet
         DEFINE Led3 = Rb,1
         DEFINE Led4 = Rb,2
         DEFINE Led5 = Rb,3
         DEFINE Led6 = Rb,4
         DEFINE Led7 = Rb,5
         DEFINE Led8 = Rb,6
         DEFINE Led9 = Rb,7

cold: 
         GOTO start                         'springe zu start
init: 
         TRIS Rb,%00000000                  'RB=Output 
         TRIS Rc,%01111111                  'RC,7=Output Rest=Input
         RETURN 

start: 
         GOSUB init                         'Lege Inputs/outputs fest
         LET Augenzahl=1                    'Anfangswert des Wuerfels
loop: 
'Anzeige auffrischen 
         WAIT 2                             'Brillianz der LEDs
         OUTPUT Rb,0                        'LED2 bis 9 aus 
         ON Augenzahl GOTO zahl0,zahl1,zahl2,zahl3,zahl4,zahl5,zahl6
zahl6:                                      'Einsprung an der Zahl 6
         SET Led5
         SET Led9
zahl5:                                       'Einsprung fr 5 und 4
zahl4:
         SET Led4
         SET Led8
zahl3:                                       'Einsprung fr 3 und 2
zahl2:
         SET Led2
         SET Led6
zahl1:                                       'Einsprung fr Zahl 1
         IF Augenzahl,0=1 THEN SET Led1 ELSE RES Led1
zahl0:

         IF Taste=1 THEN GOTO loop          'warte bis Taste gedrckt
count: 
         INC Augenzahl                      'hochzhlen 
         IF Augenzahl=7 THEN LET Augenzahl=1    'wenn 7, dann auf 1 
         GOTO loop                          'beginne von vorn
         END

